var flipper;
var lastupdated;
var stretcher;
var motdFader;
var scrollbar;
var scrollArea;
var xmlHttpRequest;

var translated_txt;
var prefLang;
var prefLogin;
var txt_en = Array();
var txt_fr = Array();

txt_en['my_links'] = 'In my links';
txt_en['all_links'] = 'In all links';
txt_en['pref_desc'] = 'Enter your KreuZZ login below to enable the search in your links';
txt_en['pref_lang'] = 'Language';

txt_fr['my_links'] = 'Mes liens';
txt_fr['all_links'] = 'Tous les liens';
txt_fr['pref_desc'] = 'Saisissez votre login KreuZZ ci-dessous pour activer la recherche dans vos liens';
txt_fr['pref_lang'] = 'Langue';

function setup() {
	flipper 	= new Fader(document.getElementById('flip'), null, 500);
	prefLang 	= 'fr';
	prefLogin 	= '';
	if ( window.widget ) {
		prefLang_saved = widget.preferenceForKey("prefLang");
		prefLogin_saved = widget.preferenceForKey("prefLogin");
		if ( prefLang_saved && prefLang_saved.length > 0 ) {
			if ( prefLang_saved == 'en' ) {
				prefLang = 'en';
				translated_txt = txt_en;				
			}
			else {
				translated_txt = txt_fr;
			}
		}
		else {
			translated_txt = txt_fr;
		}
		if ( prefLogin_saved && prefLogin_saved.length > 0 ) {
			prefLogin = prefLogin_saved;
		}
		
	}
	display_backside();
	display_searchfilter();
	
	getMessageOfTheDay();

}

function showBackside(event) {
	
	if (window.widget) {
		window.widget.prepareForTransition("ToBack");
	}
	document.getElementById("fliprollie").style.display="none";
	document.getElementById('front').style.display='none';
	document.getElementById('back').style.display='block';
	if (window.widget) {
		setTimeout("window.widget.performTransition()", 0);
	}
}	

function showFront(event) {
	if (window.widget) {
		window.widget.prepareForTransition("ToFront");
	}
	document.getElementById('back').style.display='none';
	document.getElementById('front').style.display='block';

	if (window.widget) {
		setTimeout("window.widget.performTransition()", 0);
	}
}

// retrieve message of the day from the server
function getMessageOfTheDay() {	
	document.getElementById('searchProgress').style.display = 'block';
	
	if (xmlHttpRequest != null) {
		xmlHttpRequest.abort();
		xmlHttpRequest = null;
	}

	xmlHttpRequest = new XMLHttpRequest();


	xmlHttpRequest.onload = function(e) {parseResults(e, xmlHttpRequest);}


	if ( prefLogin.length > 0 ) {
		filter = document.getElementById('searchfilter');
		search_what =filter.options[filter.selectedIndex].value;
		if ( search_what == 'all' ) {
			base_url = 'www';
		}
		else {
			base_url = prefLogin;
		}
	}
	else {
		base_url = 'www';
	}
	url = 'http://'+base_url + '.kreuzz.com/links/widget/hp/?lang='+prefLang;
	xmlHttpRequest.open("GET", url);
	xmlHttpRequest.send(null);
	document.getElementById('searchProgress').style.display = 'block';


	return "";
}

function display_searchfilter() {
	if ( window.widget ) {
	
		if ( prefLogin && prefLogin.length > 0 ) {
			document.getElementById('searchfiltercontainer').innerHTML = '<img src="Images/select_bg_gray.png" class="popupMenuImage" id="listHeaderSortBg"><div id="popupMenuText">'+translated_txt['my_links']+'</div><select id="searchfilter" onchange="change_searchfilter();"><option value="my">'+translated_txt['my_links']+'</option><option value="all">'+translated_txt['all_links']+'</option></select>';
		}
		else {
			document.getElementById('searchfiltercontainer').innerHTML = '';
		}
		
	}
}

function change_searchfilter() {
	filter = document.getElementById('searchfilter');
	
	document.getElementById('popupMenuText').innerHTML = filter.options[filter.selectedIndex].text;
	searchBookmarks(document.getElementById('searchtxt').value, '');
}

// user searches for a recipe or clicks x button in search box
function searchBookmarks(q, event) {
    q = unescape(q);
	// Reset
    if (q.length < 1) {
        document.getElementById('searchtxt').value = "";

		if (xmlHttpRequest != null) {
			xmlHttpRequest.abort();
			xmlHttpRequest = null;
		}
		getMessageOfTheDay();
		
    }
 	//search
	else {   
	    search(q,event);
    }
}

function search(q,event) {
	filter = document.getElementById('searchfilter');
	search_what =filter.options[filter.selectedIndex].value;
	
	if (xmlHttpRequest != null) {
		xmlHttpRequest.abort();
		xmlHttpRequest = null;
	}
	
	xmlHttpRequest = new XMLHttpRequest();
	if ( search_what == 'all' ) {
		base_url = 'www';
	}
	else {
		base_url = prefLogin;
	}
	url = 'http://'+base_url + '.kreuzz.com/links/widget/search/'+escape(q)+'/?lang='+prefLang;
	xmlHttpRequest.onload = function(e) {parseResults(e, xmlHttpRequest);}
	
	xmlHttpRequest.open("GET", url);
	xmlHttpRequest.setRequestHeader("Cache-Control", "no-cache");
	xmlHttpRequest.send(null);
	document.getElementById('searchProgress').style.display = 'block';
}

function parseResults(e, request) {

	
	document.getElementById('searchProgress').style.display = 'none';
	
	if (request.responseText != null) {
		document.getElementById('innerbox').innerHTML = request.responseText;
	}

	scrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollBar"));
	scrollArea = new AppleScrollArea(document.getElementById("innerbox"), scrollbar);
	scrollArea.scrollsHorizontally = false;
	scrollArea.refresh();
	

}

function savePrefs() {
	if ( window.widget ) {
		langSelect = document.getElementById('langSelector');
		loginValue = document.getElementById('kreuzzLogin');
	    widget.setPreferenceForKey(langSelect.options[langSelect.selectedIndex].value, "prefLang");
	    widget.setPreferenceForKey(loginValue.value, "prefLogin");
		prefLang = langSelect.options[langSelect.selectedIndex].value;
		prefLogin = loginValue.value;
		
		showFront();
		setup();
	}
}

function display_backside() {
	if ( prefLang && prefLang.length > 0 && prefLang == 'en' ) {
			backside_txt  = 'Language : <select id="langSelector"><option value="fr">Fran&ccedil;ais</option><option value="en" selected>English</option></select>';
			backside_txt += '<br/><br/>';
			backside_txt += 'KreuZZ Login (optional) : <input type="text" id="kreuzzLogin" value="'+prefLogin+'"/>';
			backside_txt += '<br/><br/>';
			backside_txt += '<input type="submit" value="Save" onclick="savePrefs();"/>';
			backside_txt += '<br/><br/><br/>Created by Mathieu LESNIAK (maverick@eskuel.net)';
			backside_txt += '<br/><br/><a href="javascript:openLink(\'http://www.kreuzz.com/widget/?lang=en\')">Update and information</a>';
		
	}
	else {		
		backside_txt  = 'Langue : <select id="langSelector"><option value="fr">Fran&ccedil;ais</option><option value="en">English</option></select>';
		backside_txt += '<br/><br/>';
		backside_txt += 'Login KreuZZ (optionnel) : <input type="text" id="kreuzzLogin" value="'+prefLogin+'"/>';
		backside_txt += '<br/><br/>';
		backside_txt += '<input type="submit" value="Enregistrer" onclick="savePrefs();"/>';
		backside_txt += '<br/><br/><br/>R&eacute;alis&eacute; par Mathieu LESNIAK (maverick@eskuel.net)';
		backside_txt += '<br/><br/><a href="javascript:openLink(\'http://www.kreuzz.com/widget/\')">Mise &agrave; jour et informations</a>';
		
	}
	document.getElementById('backtxt').innerHTML = backside_txt;
}

function openLink(url) {
	if (window.widget) {
		widget.openURL(url);
		return false;		
	} else {
		document.location = url;
	}
}